#!/bin/bash

ifconfig eth4 down
ifconfig eth5 down
ifconfig eth6 down

ifconfig eth5 10.0.2.2 netmask 255.255.255.0 up
ifconfig eth6 172.16.10.2 netmask 255.255.255.0 up
ifconfig eth4 10.0.4.2 netmask 255.255.255.0 up

echo "1" >/proc/sys/net/ipv4/ip_forward
echo 0 > /proc/sys/net/ipv4/conf/all/rp_filter

ip route del 172.16.20.0/24 via 10.0.2.3
var_default=`mpls nhlfe add key 0 instructions push gen 4000 nexthop eth4 ipv4 10.0.4.4| grep key |cut -c 17-26`
ip route add 172.16.20.0/24 via 10.0.4.4 mpls $var_default

var_backup=`mpls nhlfe add key 0 instructions push gen 1000 nexthop eth5 ipv4 10.0.2.3| grep key |cut -c 17-26`

mpls labelspace set dev eth5 labelspace 0
mpls ilm add label gen 2001 labelspace 0

mpls labelspace set dev eth4 labelspace 0
mpls ilm add label gen 3000 labelspace 0

default_route=1
echo "using default route"
while true
do
	sleep 1
	state=`ethtool eth4 | grep "Link detected" | grep yes`
	if [ -z "$state" ]
	then
		if [ $default_route -eq 1 ]
		then
			echo "using backup route"		
			default_route=0
			ip route del 172.16.20.0/24
			ip route add 172.16.20.0/24 via 10.0.2.3 mpls $var_backup
		fi
	else
		if [ $default_route -eq 0 ]
		then
			echo "using default route"	
			default_route=1
			ip route del 172.16.20.0/24
			ip route add 172.16.20.0/24 via 10.0.4.4 mpls $var_default		
		fi
	fi
done
