#!/bin/bash

ifconfig eth0 down
ifconfig eth1 down
ifconfig eth2 down

ifconfig eth0 10.0.4.4 netmask 255.255.255.0 up
ifconfig eth1 172.16.20.4 netmask 255.255.255.0 up
ifconfig eth2 10.0.6.4 netmask 255.255.255.0 up

echo "1" >/proc/sys/net/ipv4/ip_forward
echo 0 > /proc/sys/net/ipv4/conf/all/rp_filter

ip route del 172.16.10.0/24 via 10.0.6.3

var_backup=`mpls nhlfe add key 0 instructions push gen 2000 nexthop eth2 ipv4 10.0.6.3 |grep key | cut -c 17-26`

var_default=`mpls nhlfe add key 0 instructions push gen 3000 nexthop eth0 ipv4 10.0.4.2 |grep key | cut -c 17-26`
ip route add 172.16.10.0/24 via 10.0.4.2 mpls $var_default

mpls labelspace set dev eth2 labelspace 0
mpls ilm add label gen 1001 labelspace 0

mpls labelspace set dev eth0 labelspace 0
mpls ilm add label gen 4000 labelspace 0

default_route=1
while true
do
	sleep 0.5
	state=`ethtool eth0 | grep "Link detected" | grep yes`
	if [ -z "$state" ] 
		then
		if [ $default_route -eq 1 ]
		then
			default_route=0;
			ip route del 172.16.10.0/24 via 10.0.4.2
			ip route add 172.16.10.0/24 via 10.0.6.3 mpls $var_backup
			echo "using backup route"
  		fi
	else 
		if [ $default_route -eq 0 ]
		then
			default_route=1;
			ip route del 172.16.10.0/24 via 10.0.6.3
			ip route add 172.16.10.0/24 via 10.0.4.2 mpls $var_default
			echo "using default route" 
		fi	
	fi
done
