#!/bin/bash

ifconfig eth4 down
ifconfig eth5 down
ifconfig eth6 down

ifconfig eth4 10.0.2.2 netmask 255.255.255.0 up
ifconfig eth6 172.16.10.2 netmask 255.255.255.0 up
ifconfig eth5 10.0.4.2 netmask 255.255.255.0 up 

echo "1" >/proc/sys/net/ipv4/ip_forward
echo 0 > /proc/sys/net/ipv4/conf/all/rp_filter

echo Setting MPLS for R2

mpls labelspace set dev eth4 labelspace 0
mpls ilm add label gen 2001 labelspace 0

var=`mpls nhlfe add key 0 instructions push gen 1000 nexthop eth4 ipv4 10.0.2.3| grep key |cut -c 17-26`
ip route add 172.16.20.0/24 via 10.0.2.3 mpls $var

mpls labelspace set dev eth5 labelspace 0
mpls ilm add label gen 3001 labelspace 0

var2=`mpls nhlfe add key 0 instructions push gen 4000 nexthop eth5 ipv4 10.0.4.4| grep key |cut -c 17-26`
ip route add 10.0.6.0/24 via 10.0.4.4 mpls $var2
